#
#  sosu for PowerShell
#
#    2014/01/28 V0.10 port to PowerShell
#

function get_ms()
{
	$cur = (get-date -Format "hh,mm,ss,fff").split(",")
	# ms
	$ms = (([Int32]$cur[0]) * 3600 + ([Int32]$cur[1]) * 60 + ([Int32]$cur[2]))*1000 + [Int32]$cur[3]
	Write-Output $ms
}

$ver      = "V0.10"
$max      = 10000    # max sosu
$vf       = 0        # disp sosu
$calc_cnt = 0        # num of calc
$nsosu    = 0        # num of sosu

for ($i=0; $i -lt $Args.Length; $i++) {
	if ($Args[$i] -eq "-h") {
		Write-Output "usage: sosu.ps1 [-v] [num<$max>]"
		exit
	}
	if ($Args[$i] -eq "-v") {
		$vf = 1
		continue
	}
	$max = $Args[$i]
}

$st_num = 2
$en_num = $max

Write-Output "sosu $ver by oga."
Write-Output "Sosu Start($max)..."

$brk    = 0
$start = get_ms

for ($x = $st_num; $x -le $en_num; $x++) {
	$brk = 0
	for ($i = 2; $i -lt $x; $i++) {
		$calc_cnt++
		if (($x % $i) -eq 0) {
			$brk = 1
			break
		}
	}
	if ($brk -eq 0) {
		$sosu_cnt++
		if ($vf -ne 0) {
			Write-Output " $x"
		}
	}
}

$end   = get_ms

$result = $end - $start
$result_sec = $result/1000

Write-Output "MAX $max CALC=$calc_cnt TIME=$result_sec sec"

if ($max -eq 10000) {
	[Int32]$smark = (100*1000)/$result
	Write-Output "S'Mark99 => $smark"
}





